/**************************************************************
 * Helper.h 
 *
 * Copyright (C) 2002 - Pacific Star Technologies Ltd 
 * All Rights Reserved. Unauthorized dissemination of this file
 * is strictly prohibited.
 *
 * Created: Aug 28, 2002 
 *************************************************************/
#ifndef HELPER_H_
#define HELPER_H_
#include <windows.h>

#define CHECK_HR(hr)  if (FAILED(hr)) return hr;
#define SAFE_REL(ptr)  (ptr && ptr->Release(), ptr = NULL)

HRESULT RbtRegisterModule(LPCTSTR, CLSID);
HRESULT RbtUnregisterModule(LPCTSTR);
HRESULT RbtRegisterObject(TCHAR *modPath, TCHAR *verProgId, TCHAR *progId, TCHAR *desc, CLSID clsid);
HRESULT RbtUnregisterObject(TCHAR *verProgId, TCHAR *progId, CLSID clsid);

LPTSTR CoTaskStrDup(LPCTSTR);

class CSvrState {
public:
  CSvrState(HINSTANCE inst);
  ~CSvrState();

  void IncObjs();
  void DecObjs();
  void IncLocks();
  void DecLocks();

  ULONG objCnt;
  ULONG lockCnt;
  HINSTANCE dllInst;
  
  static CSvrState *state;
};

#endif
