/**************************************************************
 * Module.h 
 *
 * Copyright (C) 2002 - Pacific Star Technologies Ltd
 * All Rights Reserved. Unauthorized dissemination of this file
 * is strictly prohibited.
 *
 * Created: Nov 04, 2002
 *************************************************************/

#ifndef MODULE_H_ 
#define MODULE_H_

#include "RobotLib.h"
#include "Iface.h"
#include <dshow.h>
#include <qedit.h>
#include <tchar.h>

// TODO: Change module name
static const TCHAR moduleName[] = _T("Module Name");

// TODO: Change this GUID
// {55BD650B-DEA2-4339-83DD-C5EB4F066E3F}
DEFINE_GUID(CLSID_ModuleName, 
  0x55bd650b, 0xdea2, 0x4339, 0x83, 0xdd, 0xc5, 0xeb, 0x4f, 0x6, 0x6e, 0x3f);

// TODO: Change name of class
class ModuleName : public IUnknown 
{
public:
  ModuleName(IUnknown *pOuter);
  ~ModuleName();
  
  STDMETHODIMP QueryInterface(REFIID, void **);
  STDMETHODIMP_(ULONG) AddRef ();
  STDMETHODIMP_(ULONG) Release ();

private:
  // TODO: Change name of interface exported by this module, if any
  class CoModImpl: public IRbtModuleName
  {
  public:
    CoModImpl(IUnknown *, ModuleName *);
    ~CoModImpl();
    
    STDMETHODIMP QueryInterface(REFIID, void **);
    STDMETHODIMP_(ULONG) AddRef();
    STDMETHODIMP_(ULONG) Release();

    STDMETHODIMP Init(IRobot *rbt);
    STDMETHODIMP Unload();
    STDMETHODIMP GetName(LPTSTR name, UINT sz);
    STDMETHODIMP GetCLSID(CLSID *clsid);
    STDMETHODIMP GetPropertyPages(PROPSHEETPAGE *pages, UINT *numPages);

    // TODO: Actions and accessors for this interface    
  private:
    IUnknown *outer;
    ModuleName *parent;
  };

  class CoPropSpecImpl : public ISpecifyPropertyPages {
  public:
    CoPropSpecImpl(IUnknown *pOuter, ModuleName *pBack);
    ~CoPropSpecImpl();

    STDMETHODIMP QueryInterface(REFIID iid, void **ppv);
    STDMETHODIMP_(ULONG) AddRef();
    STDMETHODIMP_(ULONG) Release();

    STDMETHODIMP GetPages(CAUUID *pages);
  private:
    IUnknown *outer;
    ModuleName *parent;
  };
  
  class CoActSpecImpl : public ISpecifyActions {
  public:
    CoActSpecImpl(IUnknown *pOuter, ModuleName *pBack);
    ~CoActSpecImpl();

    STDMETHODIMP QueryInterface(REFIID iid, void **ppv);
    STDMETHODIMP_(ULONG) AddRef();
    STDMETHODIMP_(ULONG) Release();

    STDMETHODIMP GetActions(LPTSTR **actions, UINT *cnt);
    STDMETHODIMP Dispatch(LPCTSTR action);

  private:
    IUnknown *outer;
    ModuleName *parent;
  };

  friend class CoModImpl;
  friend class CoPropSpecImpl;
  friend class CoActSpecImpl;

  CoModImpl module;
  CoPropSpecImpl propSpec;
  CoActSpecImpl actSpec;
  UINT refCnt;

  IRobot *pRobot; 
  HINSTANCE dllInst;

  HRESULT Init(IRobot *rbt);
  HRESULT Unload();
  HRESULT LoadPrereqs();
  HRESULT ReadSettings();
  HRESULT SaveSettings();
};

#endif
